<?
/*
Copyright (c) 2009, 2010, Andreas 'Segaja' Schleifer

Permission to use, copy, modify, and/or distribute this software for any purpose with or
without fee is hereby granted, provided that the above copyright notice and this permission
notice appear in all copies.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS
SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL
THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY
DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
OR PERFORMANCE OF THIS SOFTWARE.
*/


error_reporting(E_ALL); // Alle PHP-Fehler anzeigen

// BasisPfad und BasisURL bestimmen...
define('__base_url', 'http://'.$_SERVER['HTTP_HOST'].preg_replace(':/core/?:i', '/', dirname($_SERVER['PHP_SELF'])));
define('__base_path', preg_replace(':/core/?:i', '/', getcwd()));

// Array fuer TSV-Konfiguration leer initiieren
$configs = array(
  'reload_time' => 0,
  'default_server_title' => 'TeamSpeak-Server',
  'show_welcome_message' => 1,
  'show_channel_topics' => 1,
  'show_channel_flags' => 1,
  'show_user_flags' => 1,
  'allow_channel_hiding' => 1,
  'set_window_title' => 0,
  'add_channel_links' => 1
);

// Dateien includen...
require(__base_path.'core/ts2viewer_classes.php');
require(__base_path.'core/ts2viewer_functions.php');
require(__base_path.'ts2viewer_config.php');

foreach($configs as $key => $value) { // Config-Array parsen...
  if($key != 'default_server_title') {
    $configs[$key] = intval($value);
  }
}

if($configs['add_channel_links'] == 1) { // add host and udpport to config if necessary...
  $configs['host'] = $host;
}

if(($conn = fsockopen($host, intval($queryport))) === false) { // Verbindung aufbauen...
  exit("Connection failed!\n");
}

fgets($conn); // "[TS]" abfangen

fwrite($conn, 'sel '.intval($udpport)."\n"); // Server auswaehlen

getDataFromTS($conn); // Ergebnis holen

fwrite($conn, "cl\n"); // Channelliste anfordern

$channel_array = $ca = array(); // Variablen leer initiieren

// Channelliste in Array umwandeln...
foreach(explode("\r\n", getDataFromTS($conn)) as $chanline) { // Zeilen der Channelliste durchgehen...
  $line = trim(utf8_encode(preg_replace('/\s+/', ' ', $chanline))); // Tabs gegen Leerzeichen ersetzen und Trimmen

  if(!$line || strstr($line, 'id')) { // bestimmte Faelle ueberspringen...
    continue;
  }

  $ltmp = explode('"', $line); // Zeile an " trennen

  $ltmp1 = explode(' ', trim($ltmp[0])); // vorderen Teil der Zeile an ' ' trennen

  $channel = new Channel(); // neuen Channel erstellen

  $c = 0; // Counter initialisieren

  try {
    // voderen Teil der Zeile in Channel speichern...
    foreach(array('id', 'codec', 'parent', 'order', 'maxusers') as $label) {
      $channel->{$label} = $ltmp1[$c++];
    }

    $channel->name = $ltmp[1]; // mittleren Teil der Zeile als Name in Channel speichern

    $ltmp1 = explode(' ', trim($ltmp[2])); // 3, Teil der Zeile an ' ' trennen

    $c = 0; // Counter auf 0 setzen

    foreach(array('flags', 'password') as $label) { // 3. Teil der Zeile in Channel speichern...
      $channel->{$label} = $ltmp1[$c++];
    }

    $channel->topic = $ltmp[3]; // letzten Teil der Zeile als Topic in Channel speichern
  }
  catch(Exception $e) { // Fehler abfangen...
    echo $e->getMessage();
  }

  $ca[$channel->id] = $channel; // Channel in ChannelTmp-Array eintragen
}

// Channelstruktur bauen...
foreach($ca as $id => $channel) { // ChannelTmp-Array durchgehen...
  if($channel->parent == -1) { // wenn Channel keinen Parent hat (er ist Root-Channel)...
    $channel_array[$id] = $channel; // Channel als Root-Channel in Channel-Array eintragen
  }
  else { // wenn Channel kein Root-Channel ist...
    try {
      $channel_array[$channel->parent]->children = $channel; // Channel als Child von Parentchannel einhaengen
    }
    catch(Exception $e) { // Fehler abfangen...
      echo $e->getMessage();
    }
  }
}

uasort($channel_array, 'comp'); // Channel nach Order / Alphabet sortieren

foreach($channel_array as $id => $channel) { // Children nach Order / Alphabet sortieren...
  if(count($channel->children) <= 1) { // wenn Channel nur ein Child hat...
    continue; // ueberspringen
  }

  $children = $channel->children; // Children aus Channel extrahieren

  uasort($children, 'comp'); // Children sortieren

  $channel_array[$id]->children = $children; // Children wieder in Channel einhaengen
}

fwrite($conn, "pl\n"); // Playerliste anfordern

// Playerliste in Channel einhaengen...
foreach(explode("\r\n", getDataFromTS($conn)) as $playerline) { // Zeilen der Playerliste durchgehen...
  $line = trim(preg_replace('/\s+/', ' ', $playerline)); // Tabs gegen Leerzeichen ersetzen und Trimmen

  if(!$line || strstr($line, 'p_id')) { // bestimmte Faelle ueberspringen...
    continue;
  }

  $ltmp = explode('"', $line); // Zaile an " teilen

  $ltmp1 = explode(' ', trim($ltmp[0])); // 1. Teil der Zeile an ' ' trennen

  $player = new User(); // neuen User erstellen

  $c = 0; // Counter auf 0 setzen

  $player->id = $ltmp1[$c++]; // 1. Element des 1. Teils der Zeile als ID in User speichern

  // Uservariablen in User speichern...
  foreach(array('c_id', 'ps', 'bs', 'pr', 'br', 'pl', 'ping', 'logintime', 'idletime', 'cprivs', 'pprivs', 'pflags') as $label) {
    $player->{$label} = $ltmp1[$c++];
  }

  $player->ip = $ltmp[1]; // 2. Teil der Zeile als IP in User speichern
  $player->nick = utf8_encode($ltmp[3]); // 4. Teil der Zeile als Nick in User speichern
  $player->loginname = $ltmp[5]; // 6. Teil der Zeile als Loginname in User speichern

  try {
    $ca[$player->c_id]->user = $player; // User in den Channel im Channel-Array einhaengen, wo er ist
  }
  catch(Exception $e) { // Fehler abfangen...
    echo $e->getMessage();
  }
}

$si_array = array(); // Array leer erstellen

fwrite($conn, "si\n"); // Serverinformationen anfordern

// Serverinformationen verarbeiten...
foreach(explode("\r\n", getDataFromTS($conn)) as $sinfo) { // Zeilen der Serverinformationen durchgehen...
  $line = trim(preg_replace('/\s+/', ' ', $sinfo)); // Tabs gegen Leerzeichen ersetzen und Trimmen

  if(!$line) { // bestimmte Faelle ueberspringen...
    continue;
  }

  $tmp = explode('=', $line); // Zeile an '=' teilen

  $si_array[$tmp[0]] = utf8_encode($tmp[1]); // Zeile in Serverinformations-Array speichern
}

fclose($conn); // Verbindung zum TeamSpeak-Server schliessen


// --- XML bauen und ausgeben ---
header("Content-type: application/xml; charset='utf-8'"); // XML-Header setzen

$xml = new DOMDocument('1.0', 'UTF-8'); // XML-Document erzeugen

$node_root = $xml->appendChild(new DOMElement('teamspeak')); // Root-Element erzeugen

// --- Configs in XML einhaengen - Anfang ---
$node_configs = $node_root->appendChild(new DOMElement('configs'));

appendArrayToXML($node_configs, $configs);
// --- Configs in XML einhaengen - Ende ---

// --- Serverinformationen in XML einhaengen - Anfang ---
$node_serverinfos = $node_root->appendChild(new DOMElement('serverinfos'));

appendArrayToXML($node_serverinfos, $si_array);
// --- Serverinformationen in XML einhaengen - Ende ---

// --- Channels in XML einhaengen - Anfang ---
$node_channels = $node_root->appendChild(new DOMElement('channels'));

appendChannelsToXML($channel_array, $node_channels);
// --- Channels in XML einhaengen - Ende ---

echo $xml->saveXML(); // XML ausgeben
?>
