<?
/*
Copyright (c) 2009, 2010, Andreas 'Segaja' Schleifer

Permission to use, copy, modify, and/or distribute this software for any purpose with or
without fee is hereby granted, provided that the above copyright notice and this permission
notice appear in all copies.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS
SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL
THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY
DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
OR PERFORMANCE OF THIS SOFTWARE.
*/


function getDataFromTS($conn) { // Daten auslesen
  $data = ''; // Variable leer initiieren

  while(($line = fgets($conn)) != "OK\r\n") { // Zeile von der Connection holen und verarbeiten, so lange es nicht "OK" ist...
    if(strstr($line, 'ERROR')) { // wenn Zeile "ERROR" enthallt...
      exit($line); // mit Errormessage abbrechen
    }

    $data .= $line; // Zeile zum Rest hinzufuegen
  }

  return $data; // Daten zurueckgeben
}

function comp($a, $b) { // Comperator fuer Channel
  if($a->order == $b->order) { // Order ist gleich...
    $comp = strcmp($a->name, $b->name); // Namen der Channel vergleichen

    if($comp == 0) { // Namen sind gleich...
      return 0;
    }
      
    return (($comp < 0) ? -1 : 1)*1; // Namen sind verschieden
  }

  return ($a->order < $b->order) ? -1 : 1; // Order ist verschieden
}

// geht $channel_array durch und haengt die Elemente in der Form <$key>$value</$key> als XML-Nodes an $node_channels an
function appendChannelsToXML($channel_array, &$node_channels) {
  foreach($channel_array as $channel) { // alle Channel durchgehen...
    $node_channel = $node_channels->appendChild(new DOMElement('channel')); // Channel-Tag erstellen und einhaengen

    foreach($channel->getData() as $key => $value) { // Channeldaten durchgehen und als Tag einhaengen...
      $node_channel->appendChild(new DOMElement($key, str_replace('&', '&amp;', $value)));
    }

    $node_users = $node_channel->appendChild(new DOMElement('users')); // User-Tag erstellen und einhaengen

    foreach($channel->getArrayData('user') as $user) { // User des Channels durchgehen...
      $node_user = $node_users->appendChild(new DOMElement('user')); // Tag fuer den User erstellen und einhaengen

      foreach($user->getData() as $key => $value) { // User-Eigenschaften durchgehen und als Tags einhaengen...
        $node_user->appendChild(new DOMElement($key, $value));
      }
    }

    $node_children = $node_channel->appendChild(new DOMElement('children')); // Children-Tag erstellen und einhaengen

    appendChannelsToXML($channel->getArrayData('children'), $node_children); // Children einhaengen
  }
}

// geht $array durch und haengt die Elemente in der Form <$key>$value</$key> als XML-Nodes an $node an
function appendArrayToXML($node, $array) {
  foreach($array as $key => $value) { // Array durchgehen und Elemente als Tag in $node einhaengen...
    $node->appendChild(new DOMElement($key, $value));
  }
}
?>
